/*
 * AsDirectHW.h - userspace part for AsDirectHW
 *
 * Copyright © 2014 ASMedia Technology
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef __DIRECTHW_H
#define __DIRECTHW_H

#include <stdint.h>

int iopl(int unused);

unsigned char inb(unsigned short addr);
unsigned short inw(unsigned short addr);
unsigned int inl(unsigned short addr);

void outb(unsigned char val, unsigned short addr);
void outw(unsigned short val, unsigned short addr);
void outl(unsigned int val, unsigned short addr);

//RichardHsu-s
//unsigned char ReadB(unsigned short addr);
//unsigned short ReadW(unsigned short addr);
//unsigned int ReadDW(unsigned short addr);

unsigned char ReadB(unsigned short device,unsigned short addr);
unsigned short ReadW(unsigned short device,unsigned short addr);
unsigned int ReadDW(unsigned short device,unsigned short addr);

//void WriteB(unsigned char val, unsigned short addr);
//void WriteW(unsigned short val, unsigned short addr);
//void WriteDW(unsigned int val, unsigned short addr);

void WriteB(unsigned short device,unsigned char val, unsigned short addr);
void WriteW(unsigned short device,unsigned short val, unsigned short addr);
void WriteDW(unsigned short device,unsigned int val, unsigned short addr);

unsigned char PciReadB(unsigned short device, unsigned short addr);
unsigned short PciReadW(unsigned short device, unsigned short addr);
unsigned int PciReadDW(unsigned short device, unsigned short addr);

void PciWriteB(unsigned short device, unsigned short addr, unsigned char val);
void PciWriteW(unsigned short device, unsigned short addr, unsigned short val);
void PciWriteDW(unsigned short device, unsigned short addr, unsigned int val);
//RichardHsu-e

//void *map_physical(uint64_t phys_addr, size_t len);
void *map_physical(unsigned short device,uint64_t phys_addr, size_t len);
void unmap_physical(void);
//bool unmap_physical(unsigned short device,uint64_t phys_addr);
//void unmap_physical(void *virt_addr, size_t len);

typedef struct { uint32_t hi, lo; } msr_t;
msr_t rdmsr(int addr);
int wrmsr(int addr, msr_t msr);
int logical_cpu_select(int cpu);

#define INVALID_MSR_LO 0x63744857
#define INVALID_MSR_HI 0x44697265

#endif
